'coded by UEZ build 2016-08-23, thx to Eukalyptus

#include "windows.bi"
#include "fbgfx.bi"
#include "win/gdiplus.bi"
#Include "string.bi" 
#include "file.bi"

Using FB
Using GDIPLUS

Declare Function _GDIPlus_ImageLoadFromFile(ByVal sFilename As String) As Any Ptr
Declare Function _Sin6th(fX As Double) As Double
Declare Function _Cos6th(fX As Double) As Double

'Dim As String sImage = __PATH__ & "\salvador-dali 528x528.png"
Dim As String sImage = "salvador-dali 528x528.png"


If FileExists(sImage) = 0 Then
	End 0
EndIf

Type tPixels
	x As Single
	y As Single
	'vx As Single
	'vy As Single
	argb As ULong
End Type

Dim Shared gdipToken As ULONG_PTR
Dim GDIp As GdiplusStartupInput 
GDIp.GdiplusVersion = 1
GdiplusStartup(@gdipToken, @GDIp, NULL)
    
    
Dim As Single iW_Img, iH_Img
Dim As Any Ptr hImage
hImage = _GDIPlus_ImageLoadFromFile(sImage)
GdipGetImageDimension(hImage, @iW_Img, @iH_Img)

Dim Shared As ULong iW, iH, iPixels
iPixels = iW_Img * iH_Img
Dim Shared aPixels(0 To iPixels - 1) As tPixels

iW = Int(1.25 * iW_Img)
iH = Int(1.25 * iH_Img)

ScreenControl FB.SET_DRIVER_NAME, "GDI"
ScreenRes iW, iH, 24

Dim As String sTitle = "GDI Liquid Pixels / #Pixels: " & Format(iPixels, "###,") & " / FPS: "
WindowTitle sTitle

Dim as HWND hHWND
ScreenControl(FB.GET_WINDOW_HANDLE, Cast(Integer, hHWND))

Dim As HDC hDC = GetDC(hHWND)

Dim As BITMAPV5HEADER tBIV5HDR
tBIV5HDR.bV5Size = SizeOf(BITMAPV5HEADER)
tBIV5HDR.bV5Width = iW
tBIV5HDR.bV5Height = -iH
tBIV5HDR.bV5Planes = 1
tBIV5HDR.bV5BitCount = 32
tBIV5HDR.bV5Compression = 0 'BI_BITFIELDS
tBIV5HDR.bV5AlphaMask = &hFF000000
tBIV5HDR.bV5RedMask = 	&h00FF0000
tBIV5HDR.bV5GreenMask = &h0000FF00
tBIV5HDR.bV5BlueMask = 	&h000000FF
tBIV5HDR.bV5CSType = 2
tBIV5HDR.bV5Intent = 4

Dim As ULong Ptr aBitmap
Dim As HBitmap hBitmapGDI
Dim As HDC hGfxDC

hBitmapGDI = CreateDIBSection(hDC, @tBIV5HDR, DIB_RGB_COLORS, @aBitmap, NULL, NULL)
hGfxDC = CreateCompatibleDC(hDC)
Var hObjOld = SelectObject(hGfxDC, hBitmapGDI)

Dim evt As EVENT
Dim As ULong iFPS = 0, i, j, iPos, iMax = iW * iH - 1, iX, iY
Dim As ULong iSize, iARGB

Dim As Double fTimer, fSleep

For iY = 0 To iH_Img - 1
	For iX = 0 To iW_Img - 1
		aPixels(i).x = (iW - iW_Img) / 2 + iX' * 1.5
		aPixels(i).y = (iH - iH_Img) / 2 + iY' * 1.5
		GdipBitmapGetPixel(hImage, iX, iY, @iARGB)
		aPixels(i).argb = iARGB
		
		iPos = Int(aPixels(i).x) + Int(aPixels(i).y) * iW
		If iPos > iMax Then iPos = iMax
		aBitmap[iPos] = aPixels(i).argb
		i += 1
	Next
Next

iSize = iMax * 4 + 4


BitBlt(hDC, 0, 0, iW, iH, hGfxDC, 0, 0, SRCPAINT)


fSleep = Timer
fTimer = Timer

Do
	If Timer - fSleep > 3 Then
	
		Clear(*aBitmap, &h00, iSize)
		For i = 0 To iPixels - 1
					
			aPixels(i).x -= _Sin6th(aPixels(i).y / 70) - 1.200
			aPixels(i).y += _Cos6th(aPixels(i).x / 95) + 1.125
			
			If aPixels(i).x > iW Or aPixels(i).x < 0 Then
				aPixels(i).x = Abs(aPixels(i).x - iW)
			ElseIf aPixels(i).y > iH Or aPixels(i).y < 0 Then
				aPixels(i).y = Abs(aPixels(i).y - iH)
			EndIf
			
			iPos = Int(aPixels(i).x) + Int(aPixels(i).y) * iW
			If iPos > iMax Then iPos = iMax
			aBitmap[iPos] = aPixels(i).argb
			
			
			'to reduce interference
			iPos = Int(aPixels(i).x) + 1 + Int(aPixels(i).y) * iW
			If iPos > iMax Then iPos = iMax
			aBitmap[iPos] = aPixels(i).argb
			
			iPos = Int(aPixels(i).x) + (Int(aPixels(i).y) + 1) * iW
			If iPos > iMax Then iPos = iMax
			aBitmap[iPos] = aPixels(i).argb
			
			iPos = Int(aPixels(i).x) - 1 + (Int(aPixels(i).y) + 1) * iW
			If iPos > iMax Then iPos = iMax
			aBitmap[iPos] = aPixels(i).argb
			
			iPos = Int(aPixels(i).x) + (Int(aPixels(i).y) - 1) * iW
			If iPos > iMax Then iPos = iMax
			aBitmap[iPos] = aPixels(i).argb
			
		Next
		BitBlt(hDC, 0, 0, iW, iH, hGfxDC, 0, 0, SRCCOPY)
	End If
	
	iFPS += 1
	
	If Timer - fTimer > 0.99 Then
		WindowTitle sTitle & iFPS
		iFPS = 0
		fTimer = Timer
	EndIf
	
	If (ScreenEvent(@evt)) Then
		Select Case evt.Type 
			Case SC_ESCAPE, EVENT_WINDOW_CLOSE
				SelectObject(hGfxDC, hObjOld)
				ReleaseDC(hHWND, hDC)
				DeleteDC(hGfxDC)
				DeleteObject(hBitmapGDI)
				GdipDisposeImage(hImage)
				GdiplusShutdown(gdipToken)
				Exit Do
		End Select
	EndIf
	Sleep(5)
Loop


Function _GDIPlus_ImageLoadFromFile(ByVal sFilename As String) As Any Ptr
	Dim GDIpImage As Any Ptr
	If (GdipLoadImageFromFile(WStr(sFilename), @GDIpImage) <> 0) Then
		Return 0
	End If
	Return GDIpImage
End Function

'Asm functions below coded by Eukalyptus - thx.
Function _Sin6th(fX As Double) As Double 
   Asm 
      jmp _Sin6th_Start 
         _Sin6th_Mul: .double 683565275.57643158 
         _Sin6th_Div: .double -0.0000000061763971109087229 
         _Sin6th_Rnd: .double 6755399441055744.0 
       
      _Sin6th_Start: 
         movq xmm0, [fX] 
         mulsd xmm0, [_Sin6th_Mul] 
         addsd xmm0, [_Sin6th_Rnd] 
         movd ebx, xmm0 
    
         lea  eax, [ebx*2+0x80000000] 
         sar  eax, 2 
         imul eax 
         sar  ebx, 31 
         lea  eax, [edx*2-0x70000000] 
         lea  ecx, [edx*8+edx-0x24000000] 
         imul edx 
         xor  ecx, ebx 
         lea  eax, [edx*8+edx+0x44A00000] 
         imul ecx 
          
         cvtsi2sd xmm0, edx 
         mulsd xmm0, [_Sin6th_Div] 
         movq [Function], xmm0 
   End Asm 
End Function

Function _Cos6th(fX As Double) As Double 
   Asm 
      jmp _Cos6th_Start 
         _Cos6th_Mul: .double 683565275.57643158 
         _Cos6th_Div: .double -0.0000000061763971109087229 
         _Cos6th_Rnd: .double 6755399441055744.0 
       
      _Cos6th_Start: 
         movq xmm0, [fX] 
         mulsd xmm0, [_Cos6th_Mul] 
         addsd xmm0, [_Cos6th_Rnd] 
         movd ebx, xmm0 
          
         add ebx, 0x40000000 'SinToCos 
    
         lea  eax, [ebx*2+0x80000000] 
         sar  eax, 2 
         imul eax 
         sar  ebx, 31 
         lea  eax, [edx*2-0x70000000] 
         lea  ecx, [edx*8+edx-0x24000000] 
         imul edx 
         xor  ecx, ebx 
         lea  eax, [edx*8+edx+0x44A00000] 
         imul ecx 
          
         cvtsi2sd xmm0, edx 
         mulsd xmm0, [_Cos6th_Div] 
         movq [Function], xmm0 
   End Asm 
End Function 

